// demosnstrates various time functions

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

int main ()
{
    time_t rawtime, start, end;
    struct tm *timeinfo;
    char buffer [80];
    double dif;

    time ( &rawtime );
    timeinfo = localtime ( &rawtime );
    /* ctime ezample */
    printf ( "The current local time is: %s\n", ctime (&rawtime) );
    /* strftime examples */
    // hour am/pm, minute decimal
    strftime (buffer, sizeof(buffer), "12 hour,am/pm: %I:%M%p.\n", timeinfo);
    puts (buffer);
    // ymd
    strftime (buffer, sizeof(buffer), "ymd:%Y/%m/%d\n", timeinfo);
    puts (buffer);
    // ISO8601
    strftime (buffer, sizeof(buffer), "ISO8601:%Y-%m-%dT%H:%M:%S%z\n", timeinfo);
    puts (buffer);
    // preferred
    strftime (buffer, sizeof(buffer), "preferred:%c\n", timeinfo);
    puts (buffer);
    // ctime example
    time (&start);
    printf ("Please, enter some text: ");
    fgets (buffer, sizeof(buffer), stdin);
    time (&end);
    dif = difftime (end,start);
    printf ("It took you %f seconds to type %s\n", dif, buffer );
    return 0;
}
